<?php
/**
 * Ahthor: lf
 * Email: job@feehi.com
 * Blog: http://blog.feehi.com
 * Date: 2016/4/514:01
 */
namespace feehi\components;

use yii;
use yii\base\Component;
use common\models\Options;

class Feehi extends Component{

    public $website_title = 'Feehi CMS';
    public $website_language = 'en-US';
    public $website_timezone = 'Asia/Shanghai';

    public function __construct()
    {
        parent::__construct();
        $data = Options::find()->where(['type'=>Options::TYPE_SYSTEM])->asArray()->indexBy("name")->all();
        foreach($data as $k => $v){
            $this->$k = $v['value'];
        }
        if( !$this->website_title ) $this->website_title = 'Feehi CMS';
        if( !$this->website_language ) $this->website_language = 'en-US';
        if( !$this->website_timezone ) $this->website_timezone = 'Asia/Shanghai';
    }

    public function init()
    {
        parent::init(); // TODO: Change the autogenerated stub
        $data = Options::find()->where(['type'=>Options::TYPE_CUSTOM, 'autoload'=>1])->asArray()->all();//var_dump($data);die;
        foreach ($data as $v){
            $this->{$v['name']} = $v['value'];
        }
    }

    public function __set($name, $value)
    {
        $this->$name = $value;
    }

    public function __get($name)
    {
        return $this->$name;
    }

    private static function setConfig()
    {
        if(!empty(yii::$app->feehi->website_url)) yii::$app->params['site']['url'] = yii::$app->feehi->website_url;
    }

    public static function setFrontendConfig()
    {
        self::setConfig();
        if(!yii::$app->feehi->website_status) yii::$app->catchAll = ['site/offline'];
        yii::$app->language = yii::$app->feehi->website_language;
        yii::$app->timeZone = yii::$app->feehi->website_timezone;
        if(!isset(yii::$app->params['site']['url']) || empty(yii::$app->params['site']['url'])) yii::$app->params['site']['url'] = yii::$app->request->getHostInfo();
    }

    public static function setBackendConfig()
    {
        self::setConfig();
    }

}